Index: branches/network/src/util/loading/game_loader.cc
===================================================================
--- branches/network/src/util/loading/game_loader.cc	(revision 5968)
+++ branches/network/src/util/loading/game_loader.cc	(revision 5972)
@@ -46,5 +46,5 @@
 /**
  *  simple constructor
-*/
+ */
 GameLoader::GameLoader ()
 {
@@ -55,7 +55,8 @@
 
 
+
 /**
  *  simple deconstructor
-*/
+ */
 GameLoader::~GameLoader ()
 {
@@ -66,20 +67,8 @@
 
 
-/**
- *  this class is a singleton class
- * @returns an instance of itself
-
-   if you are unsure about singleton classes, check the theory out on the internet :)
-*/
-GameLoader* GameLoader::getInstance()
-{
-  if(singletonRef == NULL)
-    singletonRef = new GameLoader();
-  return singletonRef;
-}
 
 /**
  *  initializes the GameLoader
-*/
+ */
 ErrorMessage GameLoader::init()
 {
@@ -96,11 +85,12 @@
 
 
+
 /**
  *  reads a campaign definition file into a campaign class
  * @param fileName to be loaded
  * @returns the loaded campaign
-
-   this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
-*/
+ *
+ * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
+ */
 ErrorMessage GameLoader::loadCampaign(const char* fileName)
 {
@@ -117,9 +107,23 @@
 }
 
+
+
+/**
+ *  reads a campaign definition file into a campaign class
+ * @param fileName to be loaded
+ * @returns the loaded campaign
+ *
+ * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
+ */
+ErrorMessage loadNetworkCampaign(const char* name)
+{}
+
+
+
 /**
  *  loads a debug campaign for test purposes only.
  * @param campaignID the identifier of the campaign.
  * @returns error message if not able to do so.
-*/
+ */
 ErrorMessage GameLoader::loadDebugCampaign(Uint32 campaignID)
 {
@@ -156,7 +160,7 @@
 
 /**
-  *  starts the current entity
-  * @returns error code if this action has caused a error
-*/
+ *  starts the current entity
+ * @returns error code if this action has caused a error
+ */
 ErrorMessage GameLoader::start()
 {
@@ -167,13 +171,13 @@
 
 /**
-  *  stops the current entity
-  * @returns error code if this action has caused a error
-
-    ATTENTION: this function shouldn't call other functions, or if so, they must return
-    after finishing. If you ignore or forget to do so, the current entity is not able to
-    terminate and it will run in the background or the ressources can't be freed or even
-    worse: are freed and the program will end in a segmentation fault!
-    hehehe, have ya seen it... :)
-*/
+ *  stops the current entity
+ * @returns error code if this action has caused a error
+ *
+ * ATTENTION: this function shouldn't call other functions, or if so, they must return
+ * after finishing. If you ignore or forget to do so, the current entity is not able to
+ * terminate and it will run in the background or the ressources can't be freed or even
+ * worse: are freed and the program will end in a segmentation fault!
+ * hehehe, have dja seen it... :)
+ */
 void GameLoader::stop()
 {
@@ -184,9 +188,9 @@
 
 /**
-  *  pause the current entity
-  * @returns error code if this action has caused a error
-
-    this pauses the current entity or passes this call forth to the running entity.
-*/
+ *  pause the current entity
+ * @returns error code if this action has caused a error
+ *
+ * this pauses the current entity or passes this call forth to the running entity.
+ */
 ErrorMessage GameLoader::pause()
 {
@@ -198,9 +202,9 @@
 
 /**
-  *  resumes a pause
-  * @returns error code if this action has caused a error
-
-    this resumess the current entity or passes this call forth to the running entity.
-*/
+ *  resumes a pause
+ * @returns error code if this action has caused a error
+ *
+ * this resumess the current entity or passes this call forth to the running entity.
+ */
 ErrorMessage GameLoader::resume()
 {
@@ -224,7 +228,7 @@
  * @param fileName to be loaded
  * @returns the loaded campaign
-
-   this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
-*/
+ *
+ * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
+ */
 Campaign* GameLoader::fileToCampaign(const char* fileName)
 {
@@ -312,6 +316,6 @@
 
 /**
-  \brief this changes to the next level
-*/
+ *  this changes to the next level
+ */
 void GameLoader::nextLevel()
 {
@@ -322,8 +326,8 @@
 
 /**
-  \brief change to the previous level - not implemented
-
-  this propably useless
-*/
+ *  change to the previous level - not implemented
+ *
+ * this propably useless
+ */
 void GameLoader::previousLevel()
 {
@@ -335,5 +339,5 @@
  *  load a StoryEntity
  * @param element a XMLElement containing all the needed info
-*/
+ */
 BaseObject* GameLoader::fabricate(const TiXmlElement* element)
 {
Index: branches/network/src/util/loading/game_loader.h
===================================================================
--- branches/network/src/util/loading/game_loader.h	(revision 5968)
+++ branches/network/src/util/loading/game_loader.h	(revision 5972)
@@ -40,11 +40,12 @@
 {
 
+  
  public:
   ~GameLoader ();
 
-  static GameLoader* getInstance();
+  /**  this class is a singleton class @returns an instance of itself  */
+  static GameLoader* getInstance() { if(singletonRef == NULL) singletonRef = new GameLoader();  return singletonRef; }
 
   ErrorMessage init();
-  ErrorMessage loadCampaign(const char* name);
   ErrorMessage start();
   void stop();
@@ -56,7 +57,8 @@
   void previousLevel();
 
-  /** \brief a world command to send to the GameLoader @param cmd the command */
-  bool worldCommand(Command* cmd);
   ErrorMessage loadDebugCampaign(Uint32 campaignID);
+  ErrorMessage loadCampaign(const char* name);
+  ErrorMessage loadNetworkCampaign(const char* name);
+  
 
   void registerFactory( Factory* factory );
@@ -65,4 +67,5 @@
   void process(const Event &event);
 
+  
  private:
   GameLoader ();
@@ -70,4 +73,5 @@
   Campaign* fileToCampaign(const char* name);
 
+  
  private:
   static GameLoader*     singletonRef;         //!< The singleton-reference to this object